<template>
    <v-card>
        <v-card-title>{{ translate('labels.admin_settings') }}</v-card-title>
        <card-settings>
            <v-card-title>{{ translate('companies.title') }}</v-card-title>
            <div
                v-for="(select, index) in clientSelects"
                :key="select.selectedClientRole"
                class="flex gap-6 justify-between !p-0"
            >
                <v-select
                    class="w-full"
                    v-model="select.selectedClient"
                    :items="filteredCompanies()"
                    item-title="company_name"
                    :placeholder="translate('companies.select.label')"
                    item-value="id"
                    @update:model-value="onCompanyChange(select.selectedClient, index)"
                ></v-select>
                <v-select
                    class="w-full"
                    v-model="select.selectedClientRole"
                    :items="select.clientRoles"
                    item-title="name"
                    item-value="id"
                    :placeholder="translate('roles.select.label')"
                    @update:model-value="onRoleChange(select.selectedClientRole, index)"
                ></v-select>
                <div class="mt-10">
                    <ButtonDelete @click.prevent="removeSelect(index)"></ButtonDelete>
                </div>
            </div>

            <v-row>
                <v-col cols="12" v-if="showAddButton" class="flex justify-end">
                    <v-btn variant="outlined" @click="addSelect" :prepend-icon="'mdi-plus'">
                        {{ translate('labels.add') + ' ' + translate('labels.company') }}
                    </v-btn>
                </v-col>
            </v-row>
        </card-settings>
    </v-card>
</template>

<script setup lang="ts">
import { useI18n } from 'vue-i18n';
import { computed, defineEmits, ref, watch } from 'vue';
import { useRoute } from 'vue-router';

// Components
import CardSettings from '@/components/card/CardSettings.vue';
import ButtonDelete from '@/components/button/ButtonDelete.vue';

const { t: translate } = useI18n();
let clientSelects = ref([]) as any;
const emit = defineEmits(['update:modelValue']);
const route: any = useRoute();

const props = defineProps({
    clientSelects: Object,
    selectableClients: Object,
    selectedClient: Object,
    clientRoles: Object,
    selectedClientRole: Object,
});

watch(props, (p) => {
    if (route.params.id) {
        props.selectableClients.forEach((obj: any) => {
            obj.selectedClientRole !== null
                ? clientSelects.value.push({
                      selectedClient: obj.company_name,
                      selectedClientRole: obj.selectedClientRole,
                      clientRoles: obj.roles,
                  })
                : '';
        });
    }
});

const populateClientRoles = async (companyId: any, index) => {
    let client = await props.selectableClients?.find((client) => client.id === companyId);
    if (client) {
        clientSelects.value[index].clientRoles = client.roles;
        clientSelects.value[index].selectedClient = client.company_name;
        clientSelects.value[index].selectedClientRole = null;
    }
};
const onCompanyChange = (companyId: any, index: any) => {
    props.selectableClients.selectedClientIds[index] = companyId;
    populateClientRoles(companyId, index);
};
const addSelect = () => {
    if (clientSelects.value.length < props.selectableClients.length) {
        clientSelects.value.push({ selectedClient: null, clientRoles: [] });
    }
};
const removeSelect = (index: any) => {
    props.selectableClients.selectedClientIds.splice(index, 1);
    clientSelects.value.splice(index, 1);
    props.selectableClients.selectedRole.splice(index, 1);
};

const onRoleChange = (roleId: any, index: any) => {
    props.selectableClients.selectedRole[index] = roleId;
    emit('update:modelValue', props.selectableClients.selectedRole);
};

const showAddButton = computed(() => {
    return clientSelects.value.length < props.selectableClients.length;
});
const filteredCompanies = () => {
    return props.selectableClients.filter((client) => !props.selectableClients.selectedClientIds.includes(client.id));
};
</script>
